
# Autogenerated by mlir-tblgen; don't manually edit.

from ._ods_common import _cext as _ods_cext
from ._ods_common import (
    equally_sized_accessor as _ods_equally_sized_accessor,
    get_default_loc_context as _ods_get_default_loc_context,
    get_op_result_or_op_results as _get_op_result_or_op_results,
    get_op_result_or_value as _get_op_result_or_value,
    get_op_results_or_values as _get_op_results_or_values,
    segmented_accessor as _ods_segmented_accessor,
)
_ods_ir = _ods_cext.ir

import builtins
from typing import Sequence as _Sequence, Union as _Union


@_ods_cext.register_dialect
class _Dialect(_ods_ir.Dialect):
  DIALECT_NAMESPACE = "catalyst"

@_ods_cext.register_operation(_Dialect)
class AssertionOp(_ods_ir.OpView):
  OPERATION_NAME = "catalyst.assert"

  _ODS_REGIONS = (0, True)

  def __init__(self, assertion, error, *, loc=None, ip=None):
    operands = []
    results = []
    attributes = {}
    regions = None
    operands.append(_get_op_result_or_value(assertion))
    _ods_context = _ods_get_default_loc_context(loc)
    attributes["error"] = (error if (
    isinstance(error, _ods_ir.Attribute) or
    not _ods_ir.AttrBuilder.contains('StrAttr')) else
      _ods_ir.AttrBuilder.get('StrAttr')(error, context=_ods_context))
    _ods_successors = None
    super().__init__(self.build_generic(attributes=attributes, results=results, operands=operands, successors=_ods_successors, regions=regions, loc=loc, ip=ip))

  @builtins.property
  def assertion(self):
    return self.operation.operands[0]

  @builtins.property
  def error(self):
    return self.operation.attributes["error"]

  @error.setter
  def error(self, value):
    if value is None:
      raise ValueError("'None' not allowed as value for mandatory attributes")
    self.operation.attributes["error"] = value

def assert_(assertion, error, *, loc=None, ip=None) -> _ods_ir.Operation:
  return _get_op_result_or_op_results(AssertionOp(assertion=assertion, error=error, loc=loc, ip=ip))

@_ods_cext.register_operation(_Dialect)
class CallbackCallOp(_ods_ir.OpView):
  OPERATION_NAME = "catalyst.callback_call"

  _ODS_REGIONS = (0, True)

  def __init__(self, result, callee, inputs, *, loc=None, ip=None):
    operands = []
    results = []
    attributes = {}
    regions = None
    operands.extend(_get_op_results_or_values(inputs))
    _ods_context = _ods_get_default_loc_context(loc)
    attributes["callee"] = (callee if (
    isinstance(callee, _ods_ir.Attribute) or
    not _ods_ir.AttrBuilder.contains('FlatSymbolRefAttr')) else
      _ods_ir.AttrBuilder.get('FlatSymbolRefAttr')(callee, context=_ods_context))
    results.extend(result)
    _ods_successors = None
    super().__init__(self.build_generic(attributes=attributes, results=results, operands=operands, successors=_ods_successors, regions=regions, loc=loc, ip=ip))

  @builtins.property
  def inputs(self):
    _ods_variadic_group_length = len(self.operation.operands) - 1 + 1
    return self.operation.operands[0:0 + _ods_variadic_group_length]

  @builtins.property
  def callee(self):
    return self.operation.attributes["callee"]

  @callee.setter
  def callee(self, value):
    if value is None:
      raise ValueError("'None' not allowed as value for mandatory attributes")
    self.operation.attributes["callee"] = value

def callback_call(result, callee, inputs, *, loc=None, ip=None) -> _ods_ir.Value:
  return _get_op_result_or_op_results(CallbackCallOp(result=result, callee=callee, inputs=inputs, loc=loc, ip=ip))

@_ods_cext.register_operation(_Dialect)
class CallbackOp(_ods_ir.OpView):
  OPERATION_NAME = "catalyst.callback"

  _ODS_REGIONS = (1, True)

  def __init__(self, sym_name, function_type, id, argc, resc, *, arg_attrs=None, res_attrs=None, loc=None, ip=None):
    operands = []
    results = []
    attributes = {}
    regions = None
    _ods_context = _ods_get_default_loc_context(loc)
    attributes["sym_name"] = (sym_name if (
    isinstance(sym_name, _ods_ir.Attribute) or
    not _ods_ir.AttrBuilder.contains('SymbolNameAttr')) else
      _ods_ir.AttrBuilder.get('SymbolNameAttr')(sym_name, context=_ods_context))
    attributes["function_type"] = (function_type if (
    isinstance(function_type, _ods_ir.Attribute) or
    not _ods_ir.AttrBuilder.contains('anonymous_444')) else
      _ods_ir.AttrBuilder.get('anonymous_444')(function_type, context=_ods_context))
    attributes["id"] = (id if (
    isinstance(id, _ods_ir.Attribute) or
    not _ods_ir.AttrBuilder.contains('I64Attr')) else
      _ods_ir.AttrBuilder.get('I64Attr')(id, context=_ods_context))
    attributes["argc"] = (argc if (
    isinstance(argc, _ods_ir.Attribute) or
    not _ods_ir.AttrBuilder.contains('I64Attr')) else
      _ods_ir.AttrBuilder.get('I64Attr')(argc, context=_ods_context))
    attributes["resc"] = (resc if (
    isinstance(resc, _ods_ir.Attribute) or
    not _ods_ir.AttrBuilder.contains('I64Attr')) else
      _ods_ir.AttrBuilder.get('I64Attr')(resc, context=_ods_context))
    if arg_attrs is not None: attributes["arg_attrs"] = (arg_attrs if (
        isinstance(arg_attrs, _ods_ir.Attribute) or
        not _ods_ir.AttrBuilder.contains('DictArrayAttr')) else
          _ods_ir.AttrBuilder.get('DictArrayAttr')(arg_attrs, context=_ods_context))
    if res_attrs is not None: attributes["res_attrs"] = (res_attrs if (
        isinstance(res_attrs, _ods_ir.Attribute) or
        not _ods_ir.AttrBuilder.contains('DictArrayAttr')) else
          _ods_ir.AttrBuilder.get('DictArrayAttr')(res_attrs, context=_ods_context))
    _ods_successors = None
    super().__init__(self.build_generic(attributes=attributes, results=results, operands=operands, successors=_ods_successors, regions=regions, loc=loc, ip=ip))

  @builtins.property
  def sym_name(self):
    return self.operation.attributes["sym_name"]

  @sym_name.setter
  def sym_name(self, value):
    if value is None:
      raise ValueError("'None' not allowed as value for mandatory attributes")
    self.operation.attributes["sym_name"] = value

  @builtins.property
  def function_type(self):
    return self.operation.attributes["function_type"]

  @function_type.setter
  def function_type(self, value):
    if value is None:
      raise ValueError("'None' not allowed as value for mandatory attributes")
    self.operation.attributes["function_type"] = value

  @builtins.property
  def id(self):
    return self.operation.attributes["id"]

  @id.setter
  def id(self, value):
    if value is None:
      raise ValueError("'None' not allowed as value for mandatory attributes")
    self.operation.attributes["id"] = value

  @builtins.property
  def argc(self):
    return self.operation.attributes["argc"]

  @argc.setter
  def argc(self, value):
    if value is None:
      raise ValueError("'None' not allowed as value for mandatory attributes")
    self.operation.attributes["argc"] = value

  @builtins.property
  def resc(self):
    return self.operation.attributes["resc"]

  @resc.setter
  def resc(self, value):
    if value is None:
      raise ValueError("'None' not allowed as value for mandatory attributes")
    self.operation.attributes["resc"] = value

  @builtins.property
  def arg_attrs(self):
    if "arg_attrs" not in self.operation.attributes:
      return None
    return self.operation.attributes["arg_attrs"]

  @arg_attrs.setter
  def arg_attrs(self, value):
    if value is not None:
      self.operation.attributes["arg_attrs"] = value
    elif "arg_attrs" in self.operation.attributes:
      del self.operation.attributes["arg_attrs"]

  @arg_attrs.deleter
  def arg_attrs(self):
    del self.operation.attributes["arg_attrs"]

  @builtins.property
  def res_attrs(self):
    if "res_attrs" not in self.operation.attributes:
      return None
    return self.operation.attributes["res_attrs"]

  @res_attrs.setter
  def res_attrs(self, value):
    if value is not None:
      self.operation.attributes["res_attrs"] = value
    elif "res_attrs" in self.operation.attributes:
      del self.operation.attributes["res_attrs"]

  @res_attrs.deleter
  def res_attrs(self):
    del self.operation.attributes["res_attrs"]

  @builtins.property
  def body(self):
    return self.regions[0]

def callback(sym_name, function_type, id, argc, resc, *, arg_attrs=None, res_attrs=None, loc=None, ip=None) -> _ods_ir.Operation:
  return _get_op_result_or_op_results(CallbackOp(sym_name=sym_name, function_type=function_type, id=id, argc=argc, resc=resc, arg_attrs=arg_attrs, res_attrs=res_attrs, loc=loc, ip=ip))

@_ods_cext.register_operation(_Dialect)
class CustomCallOp(_ods_ir.OpView):
  OPERATION_NAME = "catalyst.custom_call"

  _ODS_REGIONS = (0, True)

  def __init__(self, result, inputs, call_target_name, *, number_original_arg=None, loc=None, ip=None):
    operands = []
    results = []
    attributes = {}
    regions = None
    operands.extend(_get_op_results_or_values(inputs))
    _ods_context = _ods_get_default_loc_context(loc)
    attributes["call_target_name"] = (call_target_name if (
    isinstance(call_target_name, _ods_ir.Attribute) or
    not _ods_ir.AttrBuilder.contains('StrAttr')) else
      _ods_ir.AttrBuilder.get('StrAttr')(call_target_name, context=_ods_context))
    if number_original_arg is not None: attributes["number_original_arg"] = (number_original_arg if (
        isinstance(number_original_arg, _ods_ir.Attribute) or
        not _ods_ir.AttrBuilder.contains('DenseI32ArrayAttr')) else
          _ods_ir.AttrBuilder.get('DenseI32ArrayAttr')(number_original_arg, context=_ods_context))
    results.extend(result)
    _ods_successors = None
    super().__init__(self.build_generic(attributes=attributes, results=results, operands=operands, successors=_ods_successors, regions=regions, loc=loc, ip=ip))

  @builtins.property
  def inputs(self):
    _ods_variadic_group_length = len(self.operation.operands) - 1 + 1
    return self.operation.operands[0:0 + _ods_variadic_group_length]

  @builtins.property
  def call_target_name(self):
    return self.operation.attributes["call_target_name"]

  @call_target_name.setter
  def call_target_name(self, value):
    if value is None:
      raise ValueError("'None' not allowed as value for mandatory attributes")
    self.operation.attributes["call_target_name"] = value

  @builtins.property
  def number_original_arg(self):
    if "number_original_arg" not in self.operation.attributes:
      return None
    return self.operation.attributes["number_original_arg"]

  @number_original_arg.setter
  def number_original_arg(self, value):
    if value is not None:
      self.operation.attributes["number_original_arg"] = value
    elif "number_original_arg" in self.operation.attributes:
      del self.operation.attributes["number_original_arg"]

  @number_original_arg.deleter
  def number_original_arg(self):
    del self.operation.attributes["number_original_arg"]

def custom_call(result, inputs, call_target_name, *, number_original_arg=None, loc=None, ip=None) -> _ods_ir.Value:
  return _get_op_result_or_op_results(CustomCallOp(result=result, inputs=inputs, call_target_name=call_target_name, number_original_arg=number_original_arg, loc=loc, ip=ip))

@_ods_cext.register_operation(_Dialect)
class LaunchKernelOp(_ods_ir.OpView):
  OPERATION_NAME = "catalyst.launch_kernel"

  _ODS_REGIONS = (0, True)

  def __init__(self, result, callee, inputs, *, loc=None, ip=None):
    operands = []
    results = []
    attributes = {}
    regions = None
    operands.extend(_get_op_results_or_values(inputs))
    _ods_context = _ods_get_default_loc_context(loc)
    attributes["callee"] = (callee if (
    isinstance(callee, _ods_ir.Attribute) or
    not _ods_ir.AttrBuilder.contains('SymbolRefAttr')) else
      _ods_ir.AttrBuilder.get('SymbolRefAttr')(callee, context=_ods_context))
    results.extend(result)
    _ods_successors = None
    super().__init__(self.build_generic(attributes=attributes, results=results, operands=operands, successors=_ods_successors, regions=regions, loc=loc, ip=ip))

  @builtins.property
  def inputs(self):
    _ods_variadic_group_length = len(self.operation.operands) - 1 + 1
    return self.operation.operands[0:0 + _ods_variadic_group_length]

  @builtins.property
  def callee(self):
    return self.operation.attributes["callee"]

  @callee.setter
  def callee(self, value):
    if value is None:
      raise ValueError("'None' not allowed as value for mandatory attributes")
    self.operation.attributes["callee"] = value

def launch_kernel(result, callee, inputs, *, loc=None, ip=None) -> _ods_ir.Value:
  return _get_op_result_or_op_results(LaunchKernelOp(result=result, callee=callee, inputs=inputs, loc=loc, ip=ip))

@_ods_cext.register_operation(_Dialect)
class ListDeallocOp(_ods_ir.OpView):
  OPERATION_NAME = "catalyst.list_dealloc"

  _ODS_REGIONS = (0, True)

  def __init__(self, list, *, loc=None, ip=None):
    operands = []
    results = []
    attributes = {}
    regions = None
    operands.append(_get_op_result_or_value(list))
    _ods_context = _ods_get_default_loc_context(loc)
    _ods_successors = None
    super().__init__(self.build_generic(attributes=attributes, results=results, operands=operands, successors=_ods_successors, regions=regions, loc=loc, ip=ip))

  @builtins.property
  def list(self):
    return self.operation.operands[0]

def list_dealloc(list, *, loc=None, ip=None) -> _ods_ir.Operation:
  return _get_op_result_or_op_results(ListDeallocOp(list=list, loc=loc, ip=ip))

@_ods_cext.register_operation(_Dialect)
class ListInitOp(_ods_ir.OpView):
  OPERATION_NAME = "catalyst.list_init"

  _ODS_REGIONS = (0, True)

  def __init__(self, list, *, loc=None, ip=None):
    operands = []
    results = []
    attributes = {}
    regions = None
    _ods_context = _ods_get_default_loc_context(loc)
    results.append(list)
    _ods_successors = None
    super().__init__(self.build_generic(attributes=attributes, results=results, operands=operands, successors=_ods_successors, regions=regions, loc=loc, ip=ip))

  @builtins.property
  def list(self):
    return self.operation.results[0]

def list_init(list, *, loc=None, ip=None) -> _ods_ir.Value:
  return _get_op_result_or_op_results(ListInitOp(list=list, loc=loc, ip=ip))

@_ods_cext.register_operation(_Dialect)
class ListLoadDataOp(_ods_ir.OpView):
  OPERATION_NAME = "catalyst.list_load_data"

  _ODS_REGIONS = (0, True)

  def __init__(self, data, list, *, loc=None, ip=None):
    operands = []
    results = []
    attributes = {}
    regions = None
    operands.append(_get_op_result_or_value(list))
    _ods_context = _ods_get_default_loc_context(loc)
    results.append(data)
    _ods_successors = None
    super().__init__(self.build_generic(attributes=attributes, results=results, operands=operands, successors=_ods_successors, regions=regions, loc=loc, ip=ip))

  @builtins.property
  def list(self):
    return self.operation.operands[0]

  @builtins.property
  def data(self):
    return self.operation.results[0]

def list_load_data(data, list, *, loc=None, ip=None) -> _ods_ir.Value:
  return _get_op_result_or_op_results(ListLoadDataOp(data=data, list=list, loc=loc, ip=ip))

@_ods_cext.register_operation(_Dialect)
class ListPopOp(_ods_ir.OpView):
  OPERATION_NAME = "catalyst.list_pop"

  _ODS_REGIONS = (0, True)

  def __init__(self, list, *, loc=None, ip=None):
    operands = []
    results = []
    attributes = {}
    regions = None
    operands.append(_get_op_result_or_value(list))
    _ods_context = _ods_get_default_loc_context(loc)
    _ods_successors = None
    super().__init__(self.build_generic(attributes=attributes, operands=operands, successors=_ods_successors, regions=regions, loc=loc, ip=ip))

  @builtins.property
  def list(self):
    return self.operation.operands[0]

  @builtins.property
  def result(self):
    return self.operation.results[0]

def list_pop(list, *, loc=None, ip=None) -> _ods_ir.Value:
  return _get_op_result_or_op_results(ListPopOp(list=list, loc=loc, ip=ip))

@_ods_cext.register_operation(_Dialect)
class ListPushOp(_ods_ir.OpView):
  OPERATION_NAME = "catalyst.list_push"

  _ODS_REGIONS = (0, True)

  def __init__(self, value, list, *, loc=None, ip=None):
    operands = []
    results = []
    attributes = {}
    regions = None
    operands.append(_get_op_result_or_value(value))
    operands.append(_get_op_result_or_value(list))
    _ods_context = _ods_get_default_loc_context(loc)
    _ods_successors = None
    super().__init__(self.build_generic(attributes=attributes, results=results, operands=operands, successors=_ods_successors, regions=regions, loc=loc, ip=ip))

  @builtins.property
  def value(self):
    return self.operation.operands[0]

  @builtins.property
  def list(self):
    return self.operation.operands[1]

def list_push(value, list, *, loc=None, ip=None) -> _ods_ir.Operation:
  return _get_op_result_or_op_results(ListPushOp(value=value, list=list, loc=loc, ip=ip))

@_ods_cext.register_operation(_Dialect)
class PrintOp(_ods_ir.OpView):
  OPERATION_NAME = "catalyst.print"

  _ODS_REGIONS = (0, True)

  def __init__(self, *, val=None, const_val=None, print_descriptor=None, loc=None, ip=None):
    operands = []
    results = []
    attributes = {}
    regions = None
    if val is not None: operands.append(_get_op_result_or_value(val))
    _ods_context = _ods_get_default_loc_context(loc)
    if const_val is not None: attributes["const_val"] = (const_val if (
        isinstance(const_val, _ods_ir.Attribute) or
        not _ods_ir.AttrBuilder.contains('StrAttr')) else
          _ods_ir.AttrBuilder.get('StrAttr')(const_val, context=_ods_context))
    if bool(print_descriptor): attributes["print_descriptor"] = _ods_ir.UnitAttr.get(
      _ods_get_default_loc_context(loc))
    _ods_successors = None
    super().__init__(self.build_generic(attributes=attributes, results=results, operands=operands, successors=_ods_successors, regions=regions, loc=loc, ip=ip))

  @builtins.property
  def val(self):
    return None if len(self.operation.operands) < 1 else self.operation.operands[0]

  @builtins.property
  def const_val(self):
    if "const_val" not in self.operation.attributes:
      return None
    return self.operation.attributes["const_val"]

  @const_val.setter
  def const_val(self, value):
    if value is not None:
      self.operation.attributes["const_val"] = value
    elif "const_val" in self.operation.attributes:
      del self.operation.attributes["const_val"]

  @const_val.deleter
  def const_val(self):
    del self.operation.attributes["const_val"]

  @builtins.property
  def print_descriptor(self):
    return "print_descriptor" in self.operation.attributes

  @print_descriptor.setter
  def print_descriptor(self, value):
    if bool(value):
      self.operation.attributes["print_descriptor"] = _ods_ir.UnitAttr.get()
    elif "print_descriptor" in self.operation.attributes:
      del self.operation.attributes["print_descriptor"]

  @print_descriptor.deleter
  def print_descriptor(self):
    del self.operation.attributes["print_descriptor"]

def print_(*, val=None, const_val=None, print_descriptor=None, loc=None, ip=None) -> _ods_ir.Operation:
  return _get_op_result_or_op_results(PrintOp(val=val, const_val=const_val, print_descriptor=print_descriptor, loc=loc, ip=ip))
